// =====================================================
//
//  lazmla
//
// A lot of code and many ideas stolen from:
//   miniLA_win
//
//   (c) miniLA Team
//
// =====================================================
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this package; see the file COPYING.  If not, write to
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.


unit ugraph;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics;

Procedure build_graph;

implementation

uses umain, uglobdat;

     Function byte2hex(b:byte):string;
var n:byte;
begin n:=(b mod 16)+48;
      if n>57 then n:=n+7;
      byte2hex:=char(n);
      n:=(b div 16)+48;
      if n>57 then n:=n+7;
      byte2hex:=char(n)+byte2hex;
end;

     Procedure plot_data;
var i,j,grafrow,mask,sigl:integer; //lastbit:boolean;
    lastbyte,value:byte;
    arraypos:longint; s:string;
begin with Fmain.wave2 do begin
      Canvas.Font.Height:=14;
      arraypos:=grafstart*grafvalperdiv; j:=grafvalperdiv div 10;
      if (arraypos+91*j)>(maxdatal-1) then
        arraypos:=maxdatal-91*j-1;
      grafrow:=1;
      //first 8 signals:
      if arraypos>grafvalperdiv  then
            lastbyte:=chandat1[arraypos-grafvalperdiv]
         else lastbyte:=0;
      if ChanUsed[1].grouped then begin //8 signals in one row:
         mask:=0; j:=1;
         for i:=1 to 8 do begin //build up mask:
           if ChanUsed[i].used then mask:=mask+j;
           j:=j*2; end;
         lastbyte:=lastbyte and mask; sigl:=0;
         for i:=0 to 90 do begin
             value:=chandat1[arraypos+(i*grafvalperdiv)div 10];
             value:=value and mask;
             if (value<>lastbyte) then begin
                Canvas.Line((i*10),(grafrow*20+23),(i*10),(grafrow*20+8));
                s:=byte2hex(lastbyte);
                sigl:=(sigl div 2)+Canvas.TextWidth(s);
                Canvas.TextOut((i*10-sigl+2),(grafrow*20+9),s);
                lastbyte:=value; sigl:=0;
             end
             else sigl:=sigl+10;
         end;
         if sigl<>0 then begin
           s:=Byte2hex(lastbyte);
           sigl:=(sigl div 2)+Canvas.TextWidth(s);
           Canvas.TextOut((i*10-sigl+2),(grafrow*20+9),s);end;
         grafrow:=grafrow+1;
      end
      else begin
        mask:=1; canvas.Pen.Color:=clBlue;
        for i:=1 to 8 do begin
          if Chanused[i].used then begin
            if (lastbyte and mask)<>0 then
              Canvas.MoveTo(0,(grafrow*20)+8)
            else Canvas.MoveTo(0,(grafrow*20)+23);
              for j:=0 to 90 do begin
                value:=ChanDat1[arraypos+(j*grafvalperdiv)div 10];
                if (lastbyte and mask)=(value and mask) then begin
                  if (value and mask)<>0 then
                    Canvas.LineTo((10*(j+1)),(grafrow*20)+8)
                  else Canvas.LineTo((10*(j+1)),(grafrow*20)+23); end
                else begin
                  if (value and mask)<>0 then begin
                    Canvas.LineTo(10*j,(grafrow*20)+8);
                    Canvas.LineTo(10*(j+1),(grafrow*20)+8); end
                  else begin
                    Canvas.LineTo(10*j,(grafrow*20)+23);
                    Canvas.LineTo(10*(j+1),(grafrow*20)+23); end
                end;
                lastbyte:=value;
              end;
          grafrow:=grafrow+1;
          end;
        mask:=mask*2;
        end;
      end;
      //second 8 signals:
      if arraypos>grafvalperdiv  then
            lastbyte:=chandat2[arraypos-grafvalperdiv]
         else lastbyte:=0;
      if ChanUsed[9].grouped then begin //8 signals in one row:
         mask:=0; j:=1;
         for i:=1 to 8 do begin //build up mask:
           if ChanUsed[i+8].used then mask:=mask+j;
           j:=j*2; end;
         lastbyte:=lastbyte and mask; sigl:=0;
         for i:=0 to 90 do begin
             value:=chandat2[arraypos+(i*grafvalperdiv)div 10];
             value:=value and mask;
             if (value<>lastbyte) then begin
                Canvas.Line((i*10),(grafrow*20+23),(i*10),(grafrow*20+8));
                s:=byte2hex(lastbyte);
                sigl:=(sigl div 2)+Canvas.TextWidth(s);
                Canvas.TextOut((i*10-sigl+2),(grafrow*20+9),s);
                lastbyte:=value; sigl:=0;
             end
             else sigl:=sigl+10;
         end;
         if sigl<>0 then begin
           s:=Byte2hex(lastbyte);
           sigl:=(sigl div 2)+Canvas.TextWidth(s);
           Canvas.TextOut((i*10-sigl+2),(grafrow*20+9),s);end;
         grafrow:=grafrow+1;
      end
      else begin
        mask:=1; canvas.Pen.Color:=clBlue;
        for i:=1 to 8 do begin
          if Chanused[i+8].used then begin
            if (lastbyte and mask)<>0 then
              Canvas.MoveTo(0,(grafrow*20)+8)
            else Canvas.MoveTo(0,(grafrow*20)+23);
              for j:=0 to 90 do begin
                value:=ChanDat2[arraypos+(j*grafvalperdiv)div 10];
                if (lastbyte and mask)=(value and mask) then begin
                  if (value and mask)<>0 then
                    Canvas.LineTo((10*(j+1)),(grafrow*20)+8)
                  else Canvas.LineTo((10*(j+1)),(grafrow*20)+23); end
                else begin
                  if (value and mask)<>0 then begin
                    Canvas.LineTo(10*j,(grafrow*20)+8);
                    Canvas.LineTo(10*(j+1),(grafrow*20)+8); end
                  else begin
                    Canvas.LineTo(10*j,(grafrow*20)+23);
                    Canvas.LineTo(10*(j+1),(grafrow*20)+23); end
                end;
                lastbyte:=value;
              end;
          grafrow:=grafrow+1;
          end;
        mask:=mask*2;
        end;
      end;

      //third 8 signals:
      if arraypos>grafvalperdiv  then
            lastbyte:=chandat3[arraypos-grafvalperdiv]
         else lastbyte:=0;
      if ChanUsed[17].grouped then begin //8 signals in one row:
         mask:=0; j:=1;
         for i:=1 to 8 do begin //build up mask:
           if ChanUsed[i+16].used then mask:=mask+j;
           j:=j*2; end;
         lastbyte:=lastbyte and mask; sigl:=0;
         for i:=0 to 90 do begin
             value:=chandat3[arraypos+(i*grafvalperdiv)div 10];
             value:=value and mask;
             if (value<>lastbyte) then begin
                Canvas.Line((i*10),(grafrow*20+23),(i*10),(grafrow*20+8));
                s:=byte2hex(lastbyte);
                sigl:=(sigl div 2)+Canvas.TextWidth(s);
                Canvas.TextOut((i*10-sigl+2),(grafrow*20+9),s);
                lastbyte:=value; sigl:=0;
             end
             else sigl:=sigl+10;
         end;
         if sigl<>0 then begin
           s:=Byte2hex(lastbyte);
           sigl:=(sigl div 2)+Canvas.TextWidth(s);
           Canvas.TextOut((i*10-sigl+2),(grafrow*20+9),s);end;
         grafrow:=grafrow+1;
      end
      else begin
        mask:=1; canvas.Pen.Color:=clBlue;
        for i:=1 to 8 do begin
          if Chanused[i+16].used then begin
            if (lastbyte and mask)<>0 then
              Canvas.MoveTo(0,(grafrow*20)+8)
            else Canvas.MoveTo(0,(grafrow*20)+23);
              for j:=0 to 90 do begin
                value:=ChanDat3[arraypos+(j*grafvalperdiv)div 10];
                if (lastbyte and mask)=(value and mask) then begin
                  if (value and mask)<>0 then
                    Canvas.LineTo((10*(j+1)),(grafrow*20)+8)
                  else Canvas.LineTo((10*(j+1)),(grafrow*20)+23); end
                else begin
                  if (value and mask)<>0 then begin
                    Canvas.LineTo(10*j,(grafrow*20)+8);
                    Canvas.LineTo(10*(j+1),(grafrow*20)+8); end
                  else begin
                    Canvas.LineTo(10*j,(grafrow*20)+23);
                    Canvas.LineTo(10*(j+1),(grafrow*20)+23); end
                end;
                lastbyte:=value;
              end;
          grafrow:=grafrow+1;
          end;
        mask:=mask*2;
        end;
      end;

      //last 8 signals:
      if arraypos>grafvalperdiv  then
            lastbyte:=chandat4[arraypos-grafvalperdiv]
         else lastbyte:=0;
      if ChanUsed[25].grouped then begin //8 signals in one row:
         mask:=0; j:=1;
         for i:=1 to 8 do begin //build up mask:
           if ChanUsed[i+24].used then mask:=mask+j;
           j:=j*2; end;
         lastbyte:=lastbyte and mask; sigl:=0;
         for i:=0 to 90 do begin
             value:=chandat4[arraypos+(i*grafvalperdiv)div 10];
             value:=value and mask;
             if (value<>lastbyte) then begin
                Canvas.Line((i*10),(grafrow*20+23),(i*10),(grafrow*20+8));
                s:=byte2hex(lastbyte);
                sigl:=(sigl div 2)+Canvas.TextWidth(s);
                Canvas.TextOut((i*10-sigl+2),(grafrow*20+9),s);
                lastbyte:=value; sigl:=0;
             end
             else sigl:=sigl+10;
         end;
         if sigl<>0 then begin
           s:=Byte2hex(lastbyte);
           sigl:=(sigl div 2)+Canvas.TextWidth(s);
           Canvas.TextOut((i*10-sigl+2),(grafrow*20+9),s);end;
         grafrow:=grafrow+1;
      end
      else begin
        mask:=1; canvas.Pen.Color:=clBlue;
        for i:=1 to 8 do begin
          if Chanused[i+24].used then begin
            if (lastbyte and mask)<>0 then
              Canvas.MoveTo(0,(grafrow*20)+8)
            else Canvas.MoveTo(0,(grafrow*20)+23);
              for j:=0 to 90 do begin
                value:=ChanDat4[arraypos+(j*grafvalperdiv)div 10];
                if (lastbyte and mask)=(value and mask) then begin
                  if (value and mask)<>0 then
                    Canvas.LineTo((10*(j+1)),(grafrow*20)+8)
                  else Canvas.LineTo((10*(j+1)),(grafrow*20)+23); end
                else begin
                  if (value and mask)<>0 then begin
                    Canvas.LineTo(10*j,(grafrow*20)+8);
                    Canvas.LineTo(10*(j+1),(grafrow*20)+8); end
                  else begin
                    Canvas.LineTo(10*j,(grafrow*20)+23);
                    Canvas.LineTo(10*(j+1),(grafrow*20)+23); end
                end;
                lastbyte:=value;
              end;
          grafrow:=grafrow+1;
          end;
        mask:=mask*2;
        end;
      end;
      Canvas.Pen.Color:=clWhite;
      end;

end;



     Procedure build_graph;

var i,j,calexp:integer; s:string; calval:real; grouped:boolean;
    r:real; l:longint;
begin
  with Fmain.wave2 do begin
       Canvas.Brush.Color:=clsilver;
       Canvas.Rectangle(0,0,Width,Height);
       Canvas.Pen.Color:=clwhite;
       Canvas.MoveTo(0,0);
       for i:=1 to 32 do
           Canvas.Line(0,(20*i+4),Width,(20*i+4));
       // TimeLine zeichnen und beschriften
       Canvas.Pen.Color:=clGreen;
       Canvas.Line(0,24,width,24);
       for i:= 0 to 91 do
         if ((i) mod 10)=0 then
            Canvas.Line((i*10),24,(i*10),16)
         else Canvas.Line((i*10),24,(i*10),20);
       Canvas.Font.Bold:=true;
       Canvas.Font.Height:=14;
       for i:= 1 to 4 do begin
           //calculate the calibration-text
           calval:=(grafstart+2*i);
           calval:=calval*grafbase; calexp:=grafunit;
           while calval>=1000 do begin
             calval:=calval/1000; calexp:=calexp+3; end;
           if calval>=100 then
              str(calval:5:2,s)
              else if calval>=10 then
                 str(Calval:5:3,s)
                 else str(Calval:5:4,s);
           s:=s+' ';
           case calexp of
               -9:s:=s+'n';
               -6:s:=s+'u';
               -3:s:=s+'m';
                3:s:=s+'k';
                else
           end;
           if Fmain.Timebase.ItemIndex=18 then
              s:=s+'c'
           else s:=s+'s';
           j:=Canvas.TextWidth(s) div 2;
           Canvas.TextOut((i*200-j),5,s); end;
       // draw trigger- and cursorpositions if visible:
       if (trigpos>=(grafstart*grafvalperdiv)) and
         (trigpos<((grafstart+9)*grafvalperdiv)) then begin
          l:=trigpos-(grafstart*grafvalperdiv);
          r:=l/grafvalperdiv; r:=r*100; I:=trunc(r);
          Canvas.Pen.Color:=clRed;
          Canvas.Line(i,height,i,0);
       end;
       if cur1pos<>0 then
         if (cur1pos>(grafstart*grafvalperdiv)) and
           (cur1pos<((grafstart+9)*grafvalperdiv)) then begin
            l:=cur1pos-(grafstart*grafvalperdiv);
            r:=l/grafvalperdiv; r:=r*100; I:=trunc(r);
            Canvas.Pen.Color:=clGreen;
            Canvas.Line(i,height,i,0);
         end;
       if cur2pos<>0 then
         if (cur2pos>(grafstart*grafvalperdiv)) and
           (cur2pos<((grafstart+9)*grafvalperdiv)) then begin
            l:=cur2pos-(grafstart*grafvalperdiv);
            r:=l/grafvalperdiv; r:=r*100; I:=trunc(r);
            Canvas.Pen.Color:=clYellow;
            Canvas.Line(i,height,i,0);
         end;
  end;
  if channels_changed then with Fmain.wave1 do begin
     Canvas.Brush.Color:=clsilver;
     Canvas.Rectangle(0,0,Width,Height);
     Canvas.Font.Height:=13;
     Canvas.Font.Bold:=true;
     Canvas.Pen.Color:=clBlack;
     grouped:=false; j:=1;
     for i:=1 to 32  do begin
         if (i mod 8)=1 then begin
            if ChanUsed[i].grouped then begin
              grouped:=true;
              str(i:2,s);
              s:= s + '.. ' +ChanUsed[i].name;
              Canvas.TextOut(4,(20*j + 9),s);
              j:=j+1;
            end
            else grouped:=false;
         end;
         if (not(grouped)) and (ChanUsed[i].used) then  begin
           str(i:2,s);
           s:= s + ': ' +ChanUsed[i].name;
           Canvas.TextOut(4,(20*j + 9),s);
           j:=j+1;
         end;

     end;
     canvas.Pen.Color:=clwhite;
     for i:=1 to 32 do
           Canvas.Line(0,(20*i+4),Width,(20*i+4));
     Canvas.Line(112,0,112,height);
  end;
  plot_data;


end;

end.

