// =====================================================
//
//  lazmla
//
// A lot of code and many ideas stolen from:
//   miniLA_win
//
//   (c) miniLA Team
//
// =====================================================
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this package; see the file COPYING.  If not, write to
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.


unit Utrig;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, Grids, Uchans, ComCtrls;

type

  { TFtrig }

  TFtrig = class(TForm)
    Bevel1: TBevel;
    Button1: TButton;
    triginvert: TCheckBox;
    Label3: TLabel;
    Label4: TLabel;
    triglength: TComboBox;
    Label2: TLabel;
    prepost: TComboBox;
    Label1: TLabel;
    trigcount: TComboBox;
    trigset: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure trigsetSelectCell(Sender: TObject; aCol, aRow: Integer;
      var CanSelect: Boolean);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Ftrig: TFtrig;

implementation

{ TFtrig }

uses uglobdat;

procedure TFtrig.Button1Click(Sender: TObject);
var i,bval:integer;
begin  mlaregs.TrigCTRL:=0;
  if trigset.Cells[1,17]<>'' then    // external trig.
    mlaregs.TrigCTRL:=3
  else if trigset.Cells[2,17]<>'' then mlaregs.TrigCTRL:=2;
  //save  internal trig.-settings
      //resolve value, edge and mask
      mlaregs.TrigVal1:=0; mlaregs.TrigVal2:=0; mlaregs.TrigEdg1:=0;
      mlaregs.TrigEdg2:=0; mlaregs.TrigMask1:=0; mlaregs.TrigMask2:=0;
      bval:=1;
      for i:=0 to 7 do begin // first 8 channels:
        //high:
        if trigset.Cells[1,i+1]<>'' then begin
          mlaregs.TrigMask1:=mlaregs.TrigMask1+bval;
          mlaregs.TrigVal1:=mlaregs.TrigVal1+bval; end;
        //low
        if trigset.Cells[2,i+1]<>'' then
          mlaregs.TrigMask1:=mlaregs.TrigMask1+bval;
        //lead
        if trigset.Cells[3,i+1]<>'' then begin
          mlaregs.TrigMask1:=mlaregs.TrigMask1+bval;
          mlaregs.TrigVal1:=mlaregs.TrigVal1+bval;
          mlaregs.TrigEdg1:=mlaregs.TrigEdg1+bval; end;
        //fall
        if trigset.Cells[4,i+1]<>'' then begin
          mlaregs.TrigMask1:=mlaregs.TrigMask1+bval;
          mlaregs.TrigEdg1:=mlaregs.TrigEdg1+bval; end;
        bval:=bval*2; // next channel
      end;
      bval:=1;
      for i:=0 to 7 do begin // second 8 channels:
        //high:
        if trigset.Cells[1,i+9]<>'' then begin
          mlaregs.TrigMask2:=mlaregs.TrigMask2+bval;
          mlaregs.TrigVal2:=mlaregs.TrigVal2+bval; end;
        //low
        if trigset.Cells[2,i+9]<>'' then
          mlaregs.TrigMask2:=mlaregs.TrigMask2+bval;
        //lead
        if trigset.Cells[3,i+9]<>'' then begin
          mlaregs.TrigMask2:=mlaregs.TrigMask2+bval;
          mlaregs.TrigVal2:=mlaregs.TrigVal2+bval;
          mlaregs.TrigEdg2:=mlaregs.TrigEdg2+bval; end;
        //fall
        if trigset.Cells[4,i+9]<>'' then begin
          mlaregs.TrigMask2:=mlaregs.TrigMask2+bval;
          mlaregs.TrigEdg2:=mlaregs.TrigEdg2+bval; end;
        bval:=bval*2; // next channel
      end;
    if triginvert.Checked then
      mlaregs.TrigCTRL:=mlaregs.TrigCTRL + 128;
    mlaregs.TrigLC:=triglength.ItemIndex+1;
    mlaregs.TrigEC:=trigcount.ItemIndex+1;
    mlaregs.PrePost:=prepost.ItemIndex;
    if mlaregs.PrePost<16 then
      trigpos:=(mlaregs.PrePost+1)*$2000
    else trigpos:=0;
  Ftrig.Close;
end;

procedure TFtrig.FormActivate(Sender: TObject);
var i,j,k:integer; s:string; grouped:boolean; c:char;
begin
     for i:=1 to 16 do begin
        str(i:2,s); s:=s+':';
        if (i mod 8)=1 then
          if ChanUsed[i].grouped then begin
            grouped:=true; c:='0'; j:=i end
            else grouped:=false;
        if ChanUsed[i].used then begin
          if grouped then begin
            trigset.Cells[0,i]:=s+ChanUsed[j].name+'.'+c;
            c:=succ(c);
          end
          else trigset.Cells[0,i]:=s+ChanUsed[i].name;end
        else trigset.Cells[0,i]:='';
        for k:=1 to 4 do trigset.Cells[k,i]:='';
      end;
      for k:=1 to 4 do trigset.Cells[k,17]:=''; //external
      //visualize the triggersettings:
      j:=1; s:='  X  ';
      for i:= 0 to 7 do begin //first 8 channels
        if ((mlaregs.TrigMask1 and j)<>0) and (ChanUsed[i+1].used) then begin
          if (mlaregs.TrigVal1 and j)<>0 then begin
             if (mlaregs.TrigEdg1 and j)<>0 then
               trigset.Cells[3,i+1]:=s
             else trigset.Cells[1,i+1]:=s;end
          else begin
             if (mlaregs.TrigEdg1 and j)<>0 then
               trigset.Cells[4,i+1]:=s
             else trigset.Cells[2,i+1]:=s;
          end;
        end;
        j:=j*2;
      end;
      j:=1;
      for i:= 0 to 7 do begin //second 8 channels
        if ((mlaregs.TrigMask2 and j)<>0) and (ChanUsed[i+9].used) then begin
          if (mlaregs.TrigVal2 and j)<>0 then begin
             if (mlaregs.TrigEdg2 and j)<>0 then
               trigset.Cells[3,i+9]:=s
             else trigset.Cells[1,i+9]:=s;end
          else begin
             if (mlaregs.TrigEdg2 and j)<>0 then
               trigset.Cells[4,i+9]:=s
             else trigset.Cells[2,i+9]:=s;
          end;
        end;
        j:=j*2;
      end;
      //external:
      if (mlaregs.TrigCTRL div 2)<>0 then begin
         if odd(mlaregs.TrigCTRL) then trigset.Cells[1,17]:=s
         else trigset.Cells[2,17]:=s; end;
      //other settings:
      if (mlaregs.TrigCTRL div 128)=1 then triginvert.Checked:=true
      else triginvert.Checked:=false;
      triglength.ItemIndex:=mlaregs.TrigLC-1;
      trigcount.ItemIndex:=mlaregs.TrigEC-1;
      prepost.ItemIndex:=mlaregs.PrePost;
      trigset.Cells[0,17]:='external';
      trigset.AutoSizeColumns;
      //trigset.CheckPosition;
end;


procedure TFtrig.FormCreate(Sender: TObject);
begin
  trigset.Cells[0,0]:='Channel:';
  trigset.Cells[1,0]:='High!';
  trigset.Cells[2,0]:='Low! ';
  trigset.Cells[3,0]:='Lead!';
  trigset.Cells[4,0]:='Fall!';
end;


procedure TFtrig.trigsetSelectCell(Sender: TObject; aCol, aRow: Integer;
  var CanSelect: Boolean);
var i:integer;
begin
  if aRow=17 then begin //external trigger:
     if (aCol<3) and (trigset.Cells[aCol,aRow]='') then begin
        trigset.Cells[1,aRow]:=''; trigset.Cells[2,aRow]:='';
        trigset.Cells[aCol,aRow]:='  X  '; end
      else trigset.Cells[aCol,aRow]:=''; end //ext.trig.
  else
    if trigset.Cells[0,aRow]<>'' then
     if trigset.Cells[aCol,aRow]='' then begin
        for i:=1 to 4 do trigset.Cells[i,aRow]:='';
        trigset.Cells[aCol,aRow]:='  X  '; end
     else trigset.Cells[aCol,aRow]:='';
end;

initialization
  {$I utrig.lrs}

end.

